
$folder   = $PSScriptRoot # aktuelles Skriptverzeichnis
$preptime = 60*1 # in Sekunden


$shell = New-Object -COMObject Shell.Application
$shellfolder = $shell.Namespace($folder)

# Dateien in Verzeichnis $folder auslesen, ohne angegebene Formate und ohne Ordner
$files = Get-ChildItem -Path $path | Where-Object { (-not $_.PSIsContainer) -and (@(".ps1", ".srt", ".txt") -notcontains $_.Extension) }

# For-Schleife durch alle gefunden Dateien
for ($i=0; $i -lt $files.Count-1; $i++) {

    $ShellFile = $shellfolder.ParseName($files[$i])

    # Videolaenge aus Dateieigenschaften in Sekunden
    $Dura = $ShellFile.ExtendedProperty("System.Media.Duration")/10e6


    $dura_end = New-TimeSpan -Seconds $Dura
    $dura_start = $dura_end - [int32]10e6*$preptime

    $new_file = $files[$i].DirectoryName + "\" + $files[$i].BaseName + ".srt"
    
    set-content -LiteralPath $new_file "1"
    Add-content -LiteralPath $new_file ($dura_start.ToString("hh\:mm\:ss") + ",000" + " --> " + $dura_end.ToString("hh\:mm\:ss") + ",000")
    Add-content -LiteralPath $new_file $files[$i+1].BaseName
}